.\" Copyright (c) 1993 University of Utah.
.\" Copyright (c) 1980, 1989, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" This code is derived from software contributed to Berkeley by
.\" the Systems Programming Group of the University of Utah Computer
.\" Science Department.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)vnconfig.8	8.1 (Berkeley) 6/5/93
.\"
.Dd July 8, 1993
.Dt VNCONFIG 8
.Os BSD 4
.Sh NAME
.Nm vnconfig
.Nd configure and enable vnode disks
.Sh SYNOPSIS
.Nm vnconfig
.Op Fl cdeguv
.Op Fl s Ar option
.Op Fl r Ar option
.Ar special_file Ar regular_file
.Op Ar feature
.Nm vnconfig
.Fl a 
.Op Fl cdeguv
.Op Fl s Ar option
.Op Fl r Ar option
.Op Fl f Ar config_file
.Sh DESCRIPTION
The
.Nm
command configures and enables vnode pseudo disk devices.
The first form of the command will associate the special file 
.Ar special_file
with the regular file
.Ar regular_file
allowing the latter to be accessed as though it were a disk.
Hence a regular file within the filesystem can be used for swapping
or can contain a filesystem that is mounted in the name space.
.Pp
Options indicate an action to be performed:
.Bl -tag -width indent
.It Fl a
Read a command file and performs the
specified actions for each device/file pair.
.It Fl c
Configure the device.
If successful, references to
.Ar special_file
will access the contents of
.Ar regular_file .
.It Fl d
Disable (if possible) the specified feature.
.It Fl e
Configure the device and enables any
.Ar feature
that was specified.
If no feature was specified,
.Fl e
is the same as
.Fl c .
.It Fl f Ar config_file
Use
.Ar config_file
as an alternate config file.
.It Fl g
Fiddle global options. 
.It Fl r Ar flag
Reset
.Ar flag .
The list of allowed flags and their meanings are:
.Bl -tag -width "follow"
.It Ar labels 
use disk/slice labels.
.It Ar follow 
debug flow in the 
.Xr vn 4
driver.
.It Ar debug 
debug data in the
.Xr vn 4
driver.
.It Ar io 
debug I/O in the
.Xr vn 4
driver.
.It Ar all 
turn on all flags.
.It Ar none
turn off all flags.
.El
.It Fl s Ar flag
Set
.Ar flag .
The list of allowed flags and their meanings are the same as for the
.Fl r
option.
.It Fl u
Disable and ``unconfigure'' the device.
.It Fl v
Print messages to stdout describing actions taken.
.El
.Pp
If no action option is given,
.Fl c
is assumed.
.Pp
The
.Ar feature
argument specifies a feature that can be enabled via the
.Fl e
option:
.Bl -tag -width indent
.It Dv swap
Swapping is enabled on the special file.
See
.Xr swapon 2 .
.It Dv Pf mountro= Pa mount_point
The special file is mounted read-only on
.Ar mount_point .
See
.Xr mount 2 .
.It Dv Pf mountrw= Pa mount_point
The special file is mounted read-write on
.Ar mount_point .
See
.Xr mount 2 .
.It Dv Pf mount= Pa mount_point
Same as ``mountrw=''.
.El
.Pp
A configuration file contains one line per device/file pair in the form:
.Bd -literal
	special_file	regular_file	[ feature ]
.Ed
.Pp
where fields are seperated by white space.
The previously described action options serve to configure, enable,
disable or unconfigure all devices in the configuration file.
.Sh FILES
.Bl -tag -width /etc/vntab -compact
.It Pa /etc/vntab
default configuration file for
.Fl a
option.
.El
.Sh EXAMPLES
.Pp
.Dl vnconfig /dev/vn0c /tmp/diskimage
.Pp
Configures the vnode disk
.Pa vn0c .
.Pp
.Dl vnconfig -e /dev/vn0c /var/swapfile swap
.Pp
Configures
.Pa vn0c
and enables swapping on it.
.Pp
.Dl vnconfig -d /dev/vn0c myfilesystem mount=/mnt
.Pp
Unmounts (disables)
.Pa vn0c .
.Pp
.Dl vnconfig -ae
.Pp
Configures and enables all devices specified in
.Pa /etc/vntab .
.Sh SEE ALSO
.Xr mount 2 ,
.Xr swapon 2 ,
.Xr unmount 2 ,
.Xr vn 4 .
